package demo7;



public class Principal {


	public static int additionner( int n, int m  ) {
		int resultat = n;
		
		if( 0 != m ){
			resultat = additionner( n + 1, m - 1 );
		}
		
		return resultat;
	}
	
	public static int additionnerIter( int n, int m  ) {
		while( 0 != m ) {
			++ n;
			-- m;
		}
		
		return n;
	}
	
	
	public static int pgcd( int n, int m ) {
		int resultat = n;
		
		if( 0 != m ) {
			resultat = pgcd( m, n % m );
		}
		
		return resultat;
	}

	public static int pgcdIter( int n, int m ) {
		while( 0 != m ) {
			int temp = n;
			n = m;
			m = temp % m;
		}
		
		return n;
	}

	
	
	
	public static String dec2bin( int n ) {
		return 0 == n ? "0" : dec2bin_rec( n );
	}

	public static String dec2bin_rec( int n ) {
		String resultat = "";
		
		if( 0 != n ) {
			resultat = dec2bin_rec( n / 2 ) + ( n % 2 );
		}
		
		return resultat;
	}

	public static String dec2binIter( int n ) {
		String resultat = 0 == n ? "0" : "";
		
		while( 0 != n ) {
			resultat = ( n % 2 ) + resultat;
			n = n / 2;
		}
		
		return resultat;
	}


	
	public static void main( String [] argv ) {
		File<Integer> f = new File<>();
		
		f.enfiler( new Integer( 5 ) );
		f.enfiler( new Integer( 8 ) );
		f.enfiler( new Integer( 11 ) );
		f.enfiler( new Integer( 14 ) );
		
		for( Integer x : f ) {
			System.out.println( x );
		}

		System.out.println( "version recursive : " );
		System.out.println( "5 + 3 = " + additionner( 5, 3 ) );		
		System.out.println( "pgcd( 72, 32 ) = " + pgcd( 72, 32 ) );
		System.out.println( "12 en binaire : " + dec2bin( 12 ) );

		System.out.println( "version iterative : " );
		System.out.println( "5 + 3 = " + additionnerIter( 5, 3 ) );		
		System.out.println( "pgcd( 72, 32 ) = " + pgcdIter( 72, 32 ) );
		System.out.println( "12 en binaire : " + dec2binIter( 12 ) );
}
}
